package com.nisum.offertransactionservice.service;

import com.nisum.offertransactionservice.converter.OfferConverter;
import com.nisum.offertransactionservice.converter.PEResponseToOfferTransactionResConverter;
import com.nisum.offertransactionservice.dao.OfferDao;
import com.nisum.offertransactionservice.model.OfferTransactionRequest;
import com.nisum.offertransactionservice.model.OfferTransactionResponse;
import com.nisum.offertransactionservice.model.PERequest;
import com.nisum.offertransactionservice.model.PEResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class OfferCallingPEService {
    @Autowired
    private OfferConverter offerConverter;

    @Autowired
    private OfferDao offerDao;
    @Autowired
    private PEResponseToOfferTransactionResConverter peResponseToOfferTransactionResConverter;

    public OfferTransactionResponse getDiscountedItemList(OfferTransactionRequest offerTransactionRequest) {
        //TODO add db call and get the Offerlookup data
        OfferTransactionResponse offerTransactionResponse ;
        PERequest peRequest = offerConverter.apply(offerTransactionRequest);
        //peRequest.setEligibleOffers();
        PEResponse peResponse = offerDao.callPE(peRequest);
        offerTransactionResponse = peResponseToOfferTransactionResConverter.apply(peResponse);
        return offerTransactionResponse;
    }
}
